#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
B0[i] = B4[i];
B1[i] = B5[i];
B2[i] = B3[i]+B5[i];
}
}

void kernel_cpu(float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,int N){
for(int i=0;i<N;i++){
B0[i] = B4[i];
B1[i] = B5[i];
B2[i] = B3[i]+B5[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "1015 ");
int size=231071;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
for(int i=0;i<231071;i++){
B0[i] = 0.359487749085*i+1;
B1[i] = 74.5790522403+i+1;
B2[i] = 15.9903708838+i+1;
B3[i] = 42.8798665997*i+1;
B4[i] = 29.7865292565*i+1;
B5[i] = 92.5187722207*i+1;
}
float *d_B0;
cudaMalloc((void **)&d_B0,231071*sizeof(float));
cudaMemcpy(d_B0,B0,231071*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,231071*sizeof(float));
cudaMemcpy(d_B1,B1,231071*sizeof(float),cudaMemcpyHostToDevice);
float *d_B2;
cudaMalloc((void **)&d_B2,231071*sizeof(float));
cudaMemcpy(d_B2,B2,231071*sizeof(float),cudaMemcpyHostToDevice);
float *d_B3;
cudaMalloc((void **)&d_B3,231071*sizeof(float));
cudaMemcpy(d_B3,B3,231071*sizeof(float),cudaMemcpyHostToDevice);
float *d_B4;
cudaMalloc((void **)&d_B4,231071*sizeof(float));
cudaMemcpy(d_B4,B4,231071*sizeof(float),cudaMemcpyHostToDevice);
float *d_B5;
cudaMalloc((void **)&d_B5,231071*sizeof(float));
cudaMemcpy(d_B5,B5,231071*sizeof(float),cudaMemcpyHostToDevice);
int n = 903*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_B0,d_B1,d_B2,d_B3,d_B4,d_B5,231071);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(B0,B1,B2,B3,B4,B5,231071);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,231071*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,231071*sizeof(int),cudaMemcpyDeviceToHost);
float *testB2;
testB2 = (float *)malloc(floatBytes);
cudaMemcpy(testB2,d_B2,231071*sizeof(int),cudaMemcpyDeviceToHost);
float *testB3;
testB3 = (float *)malloc(floatBytes);
cudaMemcpy(testB3,d_B3,231071*sizeof(int),cudaMemcpyDeviceToHost);
float *testB4;
testB4 = (float *)malloc(floatBytes);
cudaMemcpy(testB4,d_B4,231071*sizeof(int),cudaMemcpyDeviceToHost);
float *testB5;
testB5 = (float *)malloc(floatBytes);
cudaMemcpy(testB5,d_B5,231071*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<231071;i++){
}
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
free(B2);
free(testB2);
cudaFree(d_B2);
free(B3);
free(testB3);
cudaFree(d_B3);
free(B4);
free(testB4);
cudaFree(d_B4);
free(B5);
free(testB5);
cudaFree(d_B5);
printf("\n");return 0; }