#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
B0[i] = B4[i]+B6[i]*B4[i]-B5[i];
B1[i] = B5[i]/B6[i]+B5[i];
}
}

void kernel_cpu(float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,int N){
for(int i=0;i<N;i++){
B0[i] = B4[i]+B6[i]*B4[i]-B5[i];
B1[i] = B5[i]/B6[i]+B5[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "377 ");
int size=127004;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
for(int i=0;i<127004;i++){
B0[i] = 51.3440368704+i+1;
B1[i] = 0.857922355759+i+1;
B2[i] = 66.6896571072*i+1;
B3[i] = 18.1544850819*i+1;
B4[i] = 22.6103918983+i+1;
B5[i] = 38.1555696997*i+1;
B6[i] = 55.4008775144+i+1;
}
float *d_B0;
cudaMalloc((void **)&d_B0,127004*sizeof(float));
cudaMemcpy(d_B0,B0,127004*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,127004*sizeof(float));
cudaMemcpy(d_B1,B1,127004*sizeof(float),cudaMemcpyHostToDevice);
float *d_B2;
cudaMalloc((void **)&d_B2,127004*sizeof(float));
cudaMemcpy(d_B2,B2,127004*sizeof(float),cudaMemcpyHostToDevice);
float *d_B3;
cudaMalloc((void **)&d_B3,127004*sizeof(float));
cudaMemcpy(d_B3,B3,127004*sizeof(float),cudaMemcpyHostToDevice);
float *d_B4;
cudaMalloc((void **)&d_B4,127004*sizeof(float));
cudaMemcpy(d_B4,B4,127004*sizeof(float),cudaMemcpyHostToDevice);
float *d_B5;
cudaMalloc((void **)&d_B5,127004*sizeof(float));
cudaMemcpy(d_B5,B5,127004*sizeof(float),cudaMemcpyHostToDevice);
float *d_B6;
cudaMalloc((void **)&d_B6,127004*sizeof(float));
cudaMemcpy(d_B6,B6,127004*sizeof(float),cudaMemcpyHostToDevice);
int n = 497*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_B0,d_B1,d_B2,d_B3,d_B4,d_B5,d_B6,127004);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(B0,B1,B2,B3,B4,B5,B6,127004);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,127004*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,127004*sizeof(int),cudaMemcpyDeviceToHost);
float *testB2;
testB2 = (float *)malloc(floatBytes);
cudaMemcpy(testB2,d_B2,127004*sizeof(int),cudaMemcpyDeviceToHost);
float *testB3;
testB3 = (float *)malloc(floatBytes);
cudaMemcpy(testB3,d_B3,127004*sizeof(int),cudaMemcpyDeviceToHost);
float *testB4;
testB4 = (float *)malloc(floatBytes);
cudaMemcpy(testB4,d_B4,127004*sizeof(int),cudaMemcpyDeviceToHost);
float *testB5;
testB5 = (float *)malloc(floatBytes);
cudaMemcpy(testB5,d_B5,127004*sizeof(int),cudaMemcpyDeviceToHost);
float *testB6;
testB6 = (float *)malloc(floatBytes);
cudaMemcpy(testB6,d_B6,127004*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<127004;i++){
}
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
free(B2);
free(testB2);
cudaFree(d_B2);
free(B3);
free(testB3);
cudaFree(d_B3);
free(B4);
free(testB4);
cudaFree(d_B4);
free(B5);
free(testB5);
cudaFree(d_B5);
free(B6);
free(testB6);
cudaFree(d_B6);
printf("\n");return 0; }