#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(int *A0,int *A1,float *B0,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
A0[i] = A1[i];
B0[i] = B0[i]-B0[i]/B0[i];
}
}

void kernel_cpu(int *A0,int *A1,float *B0,int N){
for(int i=0;i<N;i++){
A0[i] = A1[i];
B0[i] = B0[i]-B0[i]/B0[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "467 ");
int size=795153;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
for(int i=0;i<795153;i++){
A0[i] = 93*i+1;
A1[i] = 6*i+1;
B0[i] = 50.9630105689*i+1;
}
int *d_A0;
cudaMalloc((void **)&d_A0,795153*sizeof(int));
cudaMemcpy(d_A0,A0,795153*sizeof(int),cudaMemcpyHostToDevice);
int *d_A1;
cudaMalloc((void **)&d_A1,795153*sizeof(int));
cudaMemcpy(d_A1,A1,795153*sizeof(int),cudaMemcpyHostToDevice);
float *d_B0;
cudaMalloc((void **)&d_B0,795153*sizeof(float));
cudaMemcpy(d_B0,B0,795153*sizeof(float),cudaMemcpyHostToDevice);
int n = 3107*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_A0,d_A1,d_B0,795153);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(A0,A1,B0,795153);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
int *testA0;
testA0 = (int *)malloc(intBytes);
cudaMemcpy(testA0,d_A0,795153*sizeof(int),cudaMemcpyDeviceToHost);
int *testA1;
testA1 = (int *)malloc(intBytes);
cudaMemcpy(testA1,d_A1,795153*sizeof(int),cudaMemcpyDeviceToHost);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,795153*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<795153;i++){
if (A0[i] != testA0[i]) {
printf("Invalid kernel ");
break;}
if (A1[i] != testA1[i]) {
printf("Invalid kernel ");
break;}
}
free(A0);
free(testA0);
cudaFree(d_A0);
free(A1);
free(testA1);
cudaFree(d_A1);
free(B0);
free(testB0);
cudaFree(d_B0);
printf("\n");return 0; }