#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(float *B0,float *B1,float *B2,float *B3,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
B0[i] = B3[i]*B1[i];
}
}

void kernel_cpu(float *B0,float *B1,float *B2,float *B3,int N){
for(int i=0;i<N;i++){
B0[i] = B3[i]*B1[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "550 ");
int size=187268;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
for(int i=0;i<187268;i++){
B0[i] = 8.88106468755+i+1;
B1[i] = 54.4593479248+i+1;
B2[i] = 21.1964085532+i+1;
B3[i] = 47.3266023901*i+1;
}
float *d_B0;
cudaMalloc((void **)&d_B0,187268*sizeof(float));
cudaMemcpy(d_B0,B0,187268*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,187268*sizeof(float));
cudaMemcpy(d_B1,B1,187268*sizeof(float),cudaMemcpyHostToDevice);
float *d_B2;
cudaMalloc((void **)&d_B2,187268*sizeof(float));
cudaMemcpy(d_B2,B2,187268*sizeof(float),cudaMemcpyHostToDevice);
float *d_B3;
cudaMalloc((void **)&d_B3,187268*sizeof(float));
cudaMemcpy(d_B3,B3,187268*sizeof(float),cudaMemcpyHostToDevice);
int n = 732*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_B0,d_B1,d_B2,d_B3,187268);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(B0,B1,B2,B3,187268);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,187268*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,187268*sizeof(int),cudaMemcpyDeviceToHost);
float *testB2;
testB2 = (float *)malloc(floatBytes);
cudaMemcpy(testB2,d_B2,187268*sizeof(int),cudaMemcpyDeviceToHost);
float *testB3;
testB3 = (float *)malloc(floatBytes);
cudaMemcpy(testB3,d_B3,187268*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<187268;i++){
}
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
free(B2);
free(testB2);
cudaFree(d_B2);
free(B3);
free(testB3);
cudaFree(d_B3);
printf("\n");return 0; }