#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(int *A0,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
A0[i] = A0[i]-A0[i]*A0[i]/A0[i];
B0[i] = B6[i]-B6[i];
B1[i] = B6[i]-B7[i]-B7[i];
B2[i] = B5[i];
B3[i] = B5[i]*B6[i]+B7[i]/B6[i];
B4[i] = B7[i]/B6[i]+B7[i]-B6[i];
}
}

void kernel_cpu(int *A0,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,int N){
for(int i=0;i<N;i++){
A0[i] = A0[i]-A0[i]*A0[i]/A0[i];
B0[i] = B6[i]-B6[i];
B1[i] = B6[i]-B7[i]-B7[i];
B2[i] = B5[i];
B3[i] = B5[i]*B6[i]+B7[i]/B6[i];
B4[i] = B7[i]/B6[i]+B7[i]-B6[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "555 ");
int size=184634;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
for(int i=0;i<184634;i++){
A0[i] = 89*i+1;
B0[i] = 13.4767747119+i+1;
B1[i] = 97.2864387596*i+1;
B2[i] = 24.0909659969*i+1;
B3[i] = 26.4914275595*i+1;
B4[i] = 37.2133358398*i+1;
B5[i] = 85.7615168274+i+1;
B6[i] = 32.3343916261*i+1;
B7[i] = 10.1893510824*i+1;
}
int *d_A0;
cudaMalloc((void **)&d_A0,184634*sizeof(int));
cudaMemcpy(d_A0,A0,184634*sizeof(int),cudaMemcpyHostToDevice);
float *d_B0;
cudaMalloc((void **)&d_B0,184634*sizeof(float));
cudaMemcpy(d_B0,B0,184634*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,184634*sizeof(float));
cudaMemcpy(d_B1,B1,184634*sizeof(float),cudaMemcpyHostToDevice);
float *d_B2;
cudaMalloc((void **)&d_B2,184634*sizeof(float));
cudaMemcpy(d_B2,B2,184634*sizeof(float),cudaMemcpyHostToDevice);
float *d_B3;
cudaMalloc((void **)&d_B3,184634*sizeof(float));
cudaMemcpy(d_B3,B3,184634*sizeof(float),cudaMemcpyHostToDevice);
float *d_B4;
cudaMalloc((void **)&d_B4,184634*sizeof(float));
cudaMemcpy(d_B4,B4,184634*sizeof(float),cudaMemcpyHostToDevice);
float *d_B5;
cudaMalloc((void **)&d_B5,184634*sizeof(float));
cudaMemcpy(d_B5,B5,184634*sizeof(float),cudaMemcpyHostToDevice);
float *d_B6;
cudaMalloc((void **)&d_B6,184634*sizeof(float));
cudaMemcpy(d_B6,B6,184634*sizeof(float),cudaMemcpyHostToDevice);
float *d_B7;
cudaMalloc((void **)&d_B7,184634*sizeof(float));
cudaMemcpy(d_B7,B7,184634*sizeof(float),cudaMemcpyHostToDevice);
int n = 722*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_A0,d_B0,d_B1,d_B2,d_B3,d_B4,d_B5,d_B6,d_B7,184634);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(A0,B0,B1,B2,B3,B4,B5,B6,B7,184634);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
int *testA0;
testA0 = (int *)malloc(intBytes);
cudaMemcpy(testA0,d_A0,184634*sizeof(int),cudaMemcpyDeviceToHost);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,184634*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,184634*sizeof(int),cudaMemcpyDeviceToHost);
float *testB2;
testB2 = (float *)malloc(floatBytes);
cudaMemcpy(testB2,d_B2,184634*sizeof(int),cudaMemcpyDeviceToHost);
float *testB3;
testB3 = (float *)malloc(floatBytes);
cudaMemcpy(testB3,d_B3,184634*sizeof(int),cudaMemcpyDeviceToHost);
float *testB4;
testB4 = (float *)malloc(floatBytes);
cudaMemcpy(testB4,d_B4,184634*sizeof(int),cudaMemcpyDeviceToHost);
float *testB5;
testB5 = (float *)malloc(floatBytes);
cudaMemcpy(testB5,d_B5,184634*sizeof(int),cudaMemcpyDeviceToHost);
float *testB6;
testB6 = (float *)malloc(floatBytes);
cudaMemcpy(testB6,d_B6,184634*sizeof(int),cudaMemcpyDeviceToHost);
float *testB7;
testB7 = (float *)malloc(floatBytes);
cudaMemcpy(testB7,d_B7,184634*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<184634;i++){
if (A0[i] != testA0[i]) {
printf("Invalid kernel ");
break;}
}
free(A0);
free(testA0);
cudaFree(d_A0);
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
free(B2);
free(testB2);
cudaFree(d_B2);
free(B3);
free(testB3);
cudaFree(d_B3);
free(B4);
free(testB4);
cudaFree(d_B4);
free(B5);
free(testB5);
cudaFree(d_B5);
free(B6);
free(testB6);
cudaFree(d_B6);
free(B7);
free(testB7);
cudaFree(d_B7);
printf("\n");return 0; }