#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
B0[i] = B3[i];
}
}

void kernel_cpu(float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,int N){
for(int i=0;i<N;i++){
B0[i] = B3[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "64 ");
int size=554786;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
for(int i=0;i<554786;i++){
B0[i] = 5.81612333163*i+1;
B1[i] = 24.8301028497*i+1;
B2[i] = 22.0660819414*i+1;
B3[i] = 30.7404491179+i+1;
B4[i] = 74.4285418401+i+1;
B5[i] = 22.8246044319+i+1;
B6[i] = 69.8311693555*i+1;
B7[i] = 65.6245165383*i+1;
}
float *d_B0;
cudaMalloc((void **)&d_B0,554786*sizeof(float));
cudaMemcpy(d_B0,B0,554786*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,554786*sizeof(float));
cudaMemcpy(d_B1,B1,554786*sizeof(float),cudaMemcpyHostToDevice);
float *d_B2;
cudaMalloc((void **)&d_B2,554786*sizeof(float));
cudaMemcpy(d_B2,B2,554786*sizeof(float),cudaMemcpyHostToDevice);
float *d_B3;
cudaMalloc((void **)&d_B3,554786*sizeof(float));
cudaMemcpy(d_B3,B3,554786*sizeof(float),cudaMemcpyHostToDevice);
float *d_B4;
cudaMalloc((void **)&d_B4,554786*sizeof(float));
cudaMemcpy(d_B4,B4,554786*sizeof(float),cudaMemcpyHostToDevice);
float *d_B5;
cudaMalloc((void **)&d_B5,554786*sizeof(float));
cudaMemcpy(d_B5,B5,554786*sizeof(float),cudaMemcpyHostToDevice);
float *d_B6;
cudaMalloc((void **)&d_B6,554786*sizeof(float));
cudaMemcpy(d_B6,B6,554786*sizeof(float),cudaMemcpyHostToDevice);
float *d_B7;
cudaMalloc((void **)&d_B7,554786*sizeof(float));
cudaMemcpy(d_B7,B7,554786*sizeof(float),cudaMemcpyHostToDevice);
int n = 2168*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_B0,d_B1,d_B2,d_B3,d_B4,d_B5,d_B6,d_B7,554786);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(B0,B1,B2,B3,B4,B5,B6,B7,554786);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,554786*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,554786*sizeof(int),cudaMemcpyDeviceToHost);
float *testB2;
testB2 = (float *)malloc(floatBytes);
cudaMemcpy(testB2,d_B2,554786*sizeof(int),cudaMemcpyDeviceToHost);
float *testB3;
testB3 = (float *)malloc(floatBytes);
cudaMemcpy(testB3,d_B3,554786*sizeof(int),cudaMemcpyDeviceToHost);
float *testB4;
testB4 = (float *)malloc(floatBytes);
cudaMemcpy(testB4,d_B4,554786*sizeof(int),cudaMemcpyDeviceToHost);
float *testB5;
testB5 = (float *)malloc(floatBytes);
cudaMemcpy(testB5,d_B5,554786*sizeof(int),cudaMemcpyDeviceToHost);
float *testB6;
testB6 = (float *)malloc(floatBytes);
cudaMemcpy(testB6,d_B6,554786*sizeof(int),cudaMemcpyDeviceToHost);
float *testB7;
testB7 = (float *)malloc(floatBytes);
cudaMemcpy(testB7,d_B7,554786*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<554786;i++){
}
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
free(B2);
free(testB2);
cudaFree(d_B2);
free(B3);
free(testB3);
cudaFree(d_B3);
free(B4);
free(testB4);
cudaFree(d_B4);
free(B5);
free(testB5);
cudaFree(d_B5);
free(B6);
free(testB6);
cudaFree(d_B6);
free(B7);
free(testB7);
cudaFree(d_B7);
printf("\n");return 0; }