#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
A0[i] = A6[i]/A6[i]/A6[i]/A6[i];
A1[i] = A5[i]*A6[i]*A6[i]-A6[i];
A2[i] = A6[i]-A6[i]*A5[i]+A5[i];
A3[i] = A6[i]*A5[i];
A4[i] = A6[i];
B0[i] = B4[i]-B5[i]*B5[i]*B5[i];
B1[i] = B4[i]+B4[i]+B5[i];
B2[i] = B4[i]-B5[i];
B3[i] = B4[i];
}
}

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,int N){
for(int i=0;i<N;i++){
A0[i] = A6[i]/A6[i]/A6[i]/A6[i];
A1[i] = A5[i]*A6[i]*A6[i]-A6[i];
A2[i] = A6[i]-A6[i]*A5[i]+A5[i];
A3[i] = A6[i]*A5[i];
A4[i] = A6[i];
B0[i] = B4[i]-B5[i]*B5[i]*B5[i];
B1[i] = B4[i]+B4[i]+B5[i];
B2[i] = B4[i]-B5[i];
B3[i] = B4[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "71 ");
int size=293572;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
int *A6;
A6 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
for(int i=0;i<293572;i++){
A0[i] = 3*i+1;
A1[i] = 70+i+1;
A2[i] = 59+i+1;
A3[i] = 94*i+1;
A4[i] = 83+i+1;
A5[i] = 23+i+1;
A6[i] = 49*i+1;
B0[i] = 32.8379048886+i+1;
B1[i] = 3.66510414011*i+1;
B2[i] = 73.894067159+i+1;
B3[i] = 73.3301366245+i+1;
B4[i] = 25.0258160684+i+1;
B5[i] = 91.0207373292+i+1;
}
int *d_A0;
cudaMalloc((void **)&d_A0,293572*sizeof(int));
cudaMemcpy(d_A0,A0,293572*sizeof(int),cudaMemcpyHostToDevice);
int *d_A1;
cudaMalloc((void **)&d_A1,293572*sizeof(int));
cudaMemcpy(d_A1,A1,293572*sizeof(int),cudaMemcpyHostToDevice);
int *d_A2;
cudaMalloc((void **)&d_A2,293572*sizeof(int));
cudaMemcpy(d_A2,A2,293572*sizeof(int),cudaMemcpyHostToDevice);
int *d_A3;
cudaMalloc((void **)&d_A3,293572*sizeof(int));
cudaMemcpy(d_A3,A3,293572*sizeof(int),cudaMemcpyHostToDevice);
int *d_A4;
cudaMalloc((void **)&d_A4,293572*sizeof(int));
cudaMemcpy(d_A4,A4,293572*sizeof(int),cudaMemcpyHostToDevice);
int *d_A5;
cudaMalloc((void **)&d_A5,293572*sizeof(int));
cudaMemcpy(d_A5,A5,293572*sizeof(int),cudaMemcpyHostToDevice);
int *d_A6;
cudaMalloc((void **)&d_A6,293572*sizeof(int));
cudaMemcpy(d_A6,A6,293572*sizeof(int),cudaMemcpyHostToDevice);
float *d_B0;
cudaMalloc((void **)&d_B0,293572*sizeof(float));
cudaMemcpy(d_B0,B0,293572*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,293572*sizeof(float));
cudaMemcpy(d_B1,B1,293572*sizeof(float),cudaMemcpyHostToDevice);
float *d_B2;
cudaMalloc((void **)&d_B2,293572*sizeof(float));
cudaMemcpy(d_B2,B2,293572*sizeof(float),cudaMemcpyHostToDevice);
float *d_B3;
cudaMalloc((void **)&d_B3,293572*sizeof(float));
cudaMemcpy(d_B3,B3,293572*sizeof(float),cudaMemcpyHostToDevice);
float *d_B4;
cudaMalloc((void **)&d_B4,293572*sizeof(float));
cudaMemcpy(d_B4,B4,293572*sizeof(float),cudaMemcpyHostToDevice);
float *d_B5;
cudaMalloc((void **)&d_B5,293572*sizeof(float));
cudaMemcpy(d_B5,B5,293572*sizeof(float),cudaMemcpyHostToDevice);
int n = 1147*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_A0,d_A1,d_A2,d_A3,d_A4,d_A5,d_A6,d_B0,d_B1,d_B2,d_B3,d_B4,d_B5,293572);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(A0,A1,A2,A3,A4,A5,A6,B0,B1,B2,B3,B4,B5,293572);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
int *testA0;
testA0 = (int *)malloc(intBytes);
cudaMemcpy(testA0,d_A0,293572*sizeof(int),cudaMemcpyDeviceToHost);
int *testA1;
testA1 = (int *)malloc(intBytes);
cudaMemcpy(testA1,d_A1,293572*sizeof(int),cudaMemcpyDeviceToHost);
int *testA2;
testA2 = (int *)malloc(intBytes);
cudaMemcpy(testA2,d_A2,293572*sizeof(int),cudaMemcpyDeviceToHost);
int *testA3;
testA3 = (int *)malloc(intBytes);
cudaMemcpy(testA3,d_A3,293572*sizeof(int),cudaMemcpyDeviceToHost);
int *testA4;
testA4 = (int *)malloc(intBytes);
cudaMemcpy(testA4,d_A4,293572*sizeof(int),cudaMemcpyDeviceToHost);
int *testA5;
testA5 = (int *)malloc(intBytes);
cudaMemcpy(testA5,d_A5,293572*sizeof(int),cudaMemcpyDeviceToHost);
int *testA6;
testA6 = (int *)malloc(intBytes);
cudaMemcpy(testA6,d_A6,293572*sizeof(int),cudaMemcpyDeviceToHost);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,293572*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,293572*sizeof(int),cudaMemcpyDeviceToHost);
float *testB2;
testB2 = (float *)malloc(floatBytes);
cudaMemcpy(testB2,d_B2,293572*sizeof(int),cudaMemcpyDeviceToHost);
float *testB3;
testB3 = (float *)malloc(floatBytes);
cudaMemcpy(testB3,d_B3,293572*sizeof(int),cudaMemcpyDeviceToHost);
float *testB4;
testB4 = (float *)malloc(floatBytes);
cudaMemcpy(testB4,d_B4,293572*sizeof(int),cudaMemcpyDeviceToHost);
float *testB5;
testB5 = (float *)malloc(floatBytes);
cudaMemcpy(testB5,d_B5,293572*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<293572;i++){
if (A0[i] != testA0[i]) {
printf("Invalid kernel ");
break;}
if (A1[i] != testA1[i]) {
printf("Invalid kernel ");
break;}
if (A2[i] != testA2[i]) {
printf("Invalid kernel ");
break;}
if (A3[i] != testA3[i]) {
printf("Invalid kernel ");
break;}
if (A4[i] != testA4[i]) {
printf("Invalid kernel ");
break;}
if (A5[i] != testA5[i]) {
printf("Invalid kernel ");
break;}
if (A6[i] != testA6[i]) {
printf("Invalid kernel ");
break;}
}
free(A0);
free(testA0);
cudaFree(d_A0);
free(A1);
free(testA1);
cudaFree(d_A1);
free(A2);
free(testA2);
cudaFree(d_A2);
free(A3);
free(testA3);
cudaFree(d_A3);
free(A4);
free(testA4);
cudaFree(d_A4);
free(A5);
free(testA5);
cudaFree(d_A5);
free(A6);
free(testA6);
cudaFree(d_A6);
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
free(B2);
free(testB2);
cudaFree(d_B2);
free(B3);
free(testB3);
cudaFree(d_B3);
free(B4);
free(testB4);
cudaFree(d_B4);
free(B5);
free(testB5);
cudaFree(d_B5);
printf("\n");return 0; }